
#if defined _WIN32
#	include <conio.h>
#elif defined __linux__
#	include <curses.h>
#else
#	error Operating system is undefined or unknown!
#endif

#include <jni.h>
#include "KeyBoard.h"


/*
 * Class:     it_kya_io_KeyBoard
 * Method:    read
 * Signature: ()I
 */
JNIEXPORT jint JNICALL Java_it_kya_io_KeyBoard_read
	(JNIEnv *env, jobject obj)
{
	jint ch;
#if defined _WIN32
	ch = _getch();
#elif defined __linux__
	initscr();
	cbreak();
	noecho();
	ch = getchar();
	echo();
    endwin();
	if(ch == ERR)
	{
		jclass newExc = (*env)->FindClass(env, "IOException");
		if (newExc != NULL)
		{
			(*env)->ThrowNew(env, newExc, "I/O Input error");
		}
		(*env)->DeleteLocalRef(env, newExc);
	}
#endif
	return ch;
}
